// =====================================================================
//  $Id: TOutputObjectFile.cc,v 1.5 2003/12/06 10:56:19 goiwai Exp $
//  $Name: CLDAQ-1-11-00 $
//  $Log: TOutputObjectFile.cc,v $
//  Revision 1.5  2003/12/06 10:56:19  goiwai
//  フィルタ関連の修整と Read(),Write()の戻り値の修整です.
//  Read()もWrite()も処理したレコードサイズを返します.
//  フィルタがある場合も同様です.
//  それぞれのストリームのDataSizeの扱いですが,これは扱ったレコードサイズ
//  でなく扱ったファイルやソケットなどのサイズになります.レコードサイズと
//  一致するとは限りません.
//
//  Revision 1.4  2003/10/12 13:05:33  goiwai
//  *** empty log message ***
//
//  Revision 1.3  2003/10/06 17:02:42  goiwai
//  *** empty log message ***
//
//  Revision 1.2  2003/07/30 16:19:31  goiwai
//  ファイルにコミットログをつけることにしました.
//
// =====================================================================
#include "TOutputObjectFile.hh"
#include "TObjectFilter.hh"
#include "TOutputObjectFilter.hh"

TOutputObjectFile::TOutputObjectFile( const Tstring& filename, const Tstring& mode )
  : TObjectFile( filename, mode ), TOutputObjectStream( tFileStream )
{;}

TOutputObjectFile::TOutputObjectFile( TOutputObjectFilter* filter, const Tstring& filename, const Tstring& mode )
  : TObjectFile( filename, mode ), TOutputObjectStream( filter, tFileStream )
{;}

TOutputObjectFile::~TOutputObjectFile()
{;}

Tint TOutputObjectFile::Write( TStreamableObject& object )
{
  if ( HasFilter() ) {
    return theObjectFilter -> Filtering( object, this );
  }

  theLastDataSize = theDataSize;
  theDataSize = 0;
  theDataSize = object.Record( this );
  theTotalDataSize += theDataSize;

  return theDataSize;
}
